package se;

import java.util.ArrayList;

public class EqOPConstraint extends OPConstraint{
	
	public EqOPConstraint(Value lhs,Value rhs){
		super(lhs,rhs);
	}
	
	public String print() {
		return "(" + getLhs().print() + ") = (" + getRhs().print() + ")";
	}

	public String print(int i) {
//		int j;
		String string="";
		string = string+this.getLhs().print(i)+" = "+ this.getRhs().print(0);
		return string;
	}
	
	public Value getLhs(){return super.getLhs();}
	public Value getRhs(){return super.getRhs();}
	
	//satprint
	public String satPrint(Domain dom){
		String satInputString="";
		satInputString=" (= "+this.getLhs().satString()+" "+this.getRhs().satString()+")\n";
		return satInputString;
	}
	public String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom){
		String satInputString="";
		satInputString=" (= "+this.getLhs().satString(assignment)+" "+this.getRhs().satString(assignment)+")\n";
		return satInputString;
	}
	public String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom){
//		System.out.println("DEBUG satPrint");
		String satInputString="";
		satInputString=" (= "+this.getLhs().satString(assignment)+" "+this.getRhs().satString(assignment)+")\n";
		return satInputString;
	}
	
}