package se;

import java.util.ArrayList;

public class GenericConstant extends GenericMessage  implements Constant{
	private ParametricGenericConstant parametricGenericConstant;

	public GenericConstant() {
		this.setParametricGenericConstant(new ParametricGenericConstant());
	}	
	
	public GenericConstant(String messageString){
		this();
		this.messageString = messageString;
	}
	
	public ParametricMessage eval4Domain(){return this.parametricGenericConstant;}
	public ParametricGenericConstant getParametricGenericConstant(){return this.parametricGenericConstant;}
	public void setParametricGenericConstant(ParametricGenericConstant parametricGenericConstant){
		this.parametricGenericConstant=parametricGenericConstant;}
	
	public ParametricGenericConstant eval(Environment env) {
		return getParametricGenericConstant();
	}
	
	public Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex){
		for(int i=0;i<mex_newMex.size();i++){
			if(mex_newMex.get(i).getElement0().equals(this))
				return mex_newMex.get(i).getElement1();
		}
		return this;
	}
	
	public String print() {
		return "GenericConstant "+this.hashCode();
	}
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		return list;
	}
	
	public Message getAnotherOfTheSameType(String name){
		return new GenericConstant(name);
	}
	
	//interpolantString
	public String interpolantString(Environment env){
		return this.parametricGenericConstant.satString();
	}
	
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		return this.parametricGenericConstant.satString();
	}
	
	public String interpolantString(Environment env,ArrayList<Pair<Message, ParametricMessage>> assignment){
		return this.parametricGenericConstant.satString();
	}
	
	public String toString(){
		return this.messageString;
	}
}