package se;

import java.util.Iterator;
import java.util.ArrayList;

public class IKStdConstraint extends StdConstraint{

	private IKConstraint ikconstraint;
	
	public IKStdConstraint(IKConstraint ikconstraint){
		this.ikconstraint=ikconstraint;
		StdConstraint.adddy2List(this.ikconstraint.getIK().satString());
	}
	
//	//this method returns messages to be instantiated
//	//the real satprint has to be done after domain creation (and "constantization")
//	public ArrayList<ParametricMessage> satPrint(){
//		ArrayList<ParametricMessage> ret=new ArrayList<ParametricMessage>();
//		
//		Iterator<ParametricMessage> iterator=this.ikconstraint.getIK().iterator();	
//		while (iterator.hasNext()){
//			ret.add(iterator.next());				
//		}
//				
//		ret.add(this.ikconstraint.getMessage());
//		return ret;
//	}
	
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return this.ikconstraint.getParameters(params);
	}

	
	
	//satprint
	//the following methods are not used (not anymore) but in order to not modify the structure this makes the compiler happy
	public String satPrint(Domain dom){
		return "";
	}
	public String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom){
		return "";
	}
	public String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom){
		return "";
	}


	public IKConstraint getikconstraint(){return this.ikconstraint;}
	
	public String print(){return "print IKstdConstraint";}
	public String print(int i){return "print IKstdConstraint";}
	public String getFunctionNameFromConstraint(){
		return "";
	}
	public String getConstantsFromConstraint(){
		String ret="";
		
		//reading constants from IK of IK|-m
		Iterator<ParametricMessage> iterator=this.ikconstraint.getIK().iterator();	
		while (iterator.hasNext()){
			ParametricMessage current=iterator.next();
			
				ret+=current.getConstant()+" ";
			
		}
		//reading constants from m of IK|-m
		ret+=this.ikconstraint.getMessage().getConstant();
		
		return ret;
	}
	
	public void createDomain(Domain domain){
		this.ikconstraint.getIK().add2Domain(domain,this);
		this.ikconstraint.getMessage().add2Domain(domain,this);	
		
	}
	
	
}