package se; 

import java.util.ArrayList;

public class InEqOPConstraint extends OPConstraint{
	public InEqOPConstraint(Value lhs,Value rhs){
		super(lhs,rhs);
	}
	
	public Value getLhs(){return super.getLhs();}
	public Value getRhs(){return super.getRhs();}
	

	
	public String print() {
		return "(" + getLhs().print() + ") != (" + getRhs().print() + ")";
	}
	
	public String print(int i) {
		String string="";
		string = string+this.getLhs().print(i)+" != "+ this.getRhs().print(i+1);
		return string;
	}
	
	//satprint
	public String satPrint(Domain dom){
		String satInputString="";
		satInputString=" (not (= "+this.getLhs().satString()+" "+this.getRhs().satString()+"))\n";
		return satInputString;
	}
	public String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom){
		String satInputString="";
		satInputString=" (not (= "+this.getLhs().satString(assignment)+" "+this.getRhs().satString(assignment)+"))\n";
		return satInputString;
	}
	public String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom){
		String satInputString="";
		satInputString=" (not (= "+this.getLhs().satString(assignment)+" "+this.getRhs().satString(assignment)+"))\n";
		return satInputString;
	}
}