package se;

import java.util.Iterator;
import java.io.*;

public class Interpolant{
	//TODO 
	//check (WW)
	//pair != crypt
	
	
	
	
	//here we create the partition (A,B)
	// A = \chi(s) = C /\ v=E(v)
	// B = Sem(a) /\ not(A')
	
	//in the interpolant file there are:
	//1) constraint set - OK
	//2) v=E(v) for each var in Environment - OK
	//3) (DY0 m) for each message in IK - OK - moved in Z3
	//4) for each c1 c2 constants c1!=c2 - OK  - moved in Z3
	//5) for each c constant c!=pair(m) /\ crypt(m) forall m Message - OK (MR I've used foralls) - moved in Z3
	//6) neg(DY0 m) forall m \not\in IK - OK there are parenthesis and empty vars to be checked - moved in Z3
	//7) injectivity pair and crypt - moved in Z3
	//   forall m1,m1',m2,m2' pair(m1,m2)=pair(m1',m2') => m1=m1' /\ m2=m2'
	//	 forall m1,m1',m2,m2' crypt(m1,m2)=crypt(m1',m2') => m1=m1' /\ m2=m2'
	

	
	//private String initIZ3Benchmark="\n \n:extrasorts (Message) \n:extrafuns((pair Message Message Message)(crypt Message Message Message)) \n:extrapreds ((DY0 Message) (DY1 Message))";
	private String initIZ3Benchmark="\n \n:extrafuns((pair Int Int Int)(crypt Int Int Int) "+Message.getVarsList()+" )\n:extrapreds ((DY0 Int) (DY1 Int))";
	public Interpolant(File Constraints, Environment env, int intruderSteps,String[] constantSet,Action lastAction,Formula formula){
		
		String lastActionSemantics=lastAction.toString();
		
		
//		String varList=ParametricMessage.getVarsList();
		try{

			File intTmp = File.createTempFile("iZ3_input",".tmp");
			//intTmp.deleteOnExit();
	        BufferedWriter iz3File = new BufferedWriter(new FileWriter(intTmp));
	        BufferedReader b = new BufferedReader(new FileReader(Constraints));
	        String line="";
//	        Iterator<ParametricMessage> iteratorIK0=null;
//	        Iterator<ParametricMessage> iteratorIK0_2=null; 
			
	        /**
	         * A partition
	         */
	        
	        //add constraints set C
	        //plus intruder
			while ((line=b.readLine()) != null) {
				//System.out.println("DEBUG: "+line);
				if(line.startsWith(" :logic AUFLIA")){
					iz3File.write(line);
					iz3File.write(initIZ3Benchmark+"\n");
					
				}else if(line.startsWith(":formula")){
					//iz3File.write();
					iz3File.write(line.replaceAll("formula","formula (and "));
					iz3File.write("\n");
				}else{
					iz3File.write(line+"\n");
				}
					
			
			}
			
			//add v=E(v)
			//in Environment there are only variables
			//(WW) the part of IKVar should be eliminated because already present from z3 file
			
			Iterator<DataState> iterator=env.iterator();	
			
			while (iterator.hasNext()){
				DataState currentds=iterator.next(); 
//				if(currentds.getVariable() instanceof IKVariable){
//					Iterator<ParametricMessage> iteratorPMS = ((ParametricMessageSet)currentds.getValue()).iterator();	
//					while (iteratorPMS.hasNext()){ //parsing IK0
//						iz3File.write(" (DY0 "+ iteratorPMS.next().satString()+")\n");
//					}
//				
//				}else{
				if(!(currentds.getVariable() instanceof IKVariable))
					iz3File.write(" ( = "+currentds.getVariable().interpolantString()+"  "+currentds.getValue().satString()+" ) \n");
//					iz3File.write(" ( = "+currentds.getVariable().interpolantString()+"  "+currentds.getValue().satString()+" ) \n");
				
//				}	
			}
			
			iz3File.write(" )\n"); //close the big AND
			
	        /**
	         * B partition
	         * 
	         * adding Sem(a)
	         * adding the closure n times
	         * 
	         */
			iz3File.write(" :formula \n");
			
			
			iz3File.write(" (and \n"); //init of the second big AND
			
			iz3File.write(lastActionSemantics+"\n");
			//(WW) the following should be deleted because it has been moved to Z3 file
			//add c1!=c2 and  c!=pair(m1 m2) and c!=crypt(m1 m2) /\ not(DY0 c) iff c \not\in IK0
//			for(int i=0;i<constantSet.length;i++){
//				if(!constantSet[i].equals("true")&&!constantSet[i].equals("false")){
//				iz3File.write("(forall (?afv1 Int)(?afv2 Int) (not(= "+constantSet[i]+" (pair ?afv1 ?afv2) )))\n");
//				iz3File.write("(forall (?afv1 Int)(?afv2 Int) (not(= "+constantSet[i]+" (crypt ?afv1 ?afv2) )))\n");
//				
//				//if the const is not in IK0 the I add the predicate not(DY0 m)
//				boolean c_in_ik0=false;
//				while(iteratorIK0.hasNext()){
//					if(iteratorIK0.next().satString().equals(constantSet[i])){
//						c_in_ik0=true;
//						break;
//					}
//				}
//				if(!c_in_ik0){ //we don't add (DY0 bool)
//					
//						iz3File.write("(not(DY0 "+constantSet[i]+"))");
//				}
//				//end of not(DY0 m)
//				
//				for(int j=i+1;j<constantSet.length;j++){
//					iz3File.write("(not (= "+constantSet[i]+" "+constantSet[j]+" ))\n");
//				}
//				}
//			}
			
			
//			//forall vars v, not(DY0 v) iff v \not\in IK0
//			//WARNING there are empty variables...
//			boolean v_in_ik0=false;
//			
//			String[] varListArray=varList.split(" ");
//			
//			for(int i=0;i<varListArray.length;i++){
//				while(iteratorIK0_2.hasNext()){
//					if(iteratorIK0_2.next().satString().equals(varListArray[i])){
//						v_in_ik0=true;
//						break;
//					}
//				}
//			
//				if(!v_in_ik0){	
//					if(!varListArray[i].equals("Int)")&&!varListArray[i].equals(""))
//						iz3File.write("(not(DY0 "+varListArray[i].replaceAll("\\(","")+"))\n"); //problema con le variabili
//				}
//			}
//			//end of not(DY0 m)
			
			// injectivity pair and crypt
			//   forall m1,m1',m2,m2' pair(m1,m2)=pair(m1',m2') => m1=m1' /\ m2=m2'
			//	 forall m1,m1',m2,m2' crypt(m1,m2)=crypt(m1',m2') => m1=m1' /\ m2=m2'
			
//			iz3File.write("(forall (?m1 Int)(?m11 Int)(?m2 Int)(?m21 Int) (implies(=(pair ?m1 ?m2) (pair ?m11 ?m21)) (and(= ?m1 ?m11) (= ?m2 ?m21))))\n");
//			iz3File.write("(forall (?m1 Int)(?m11 Int)(?m2 Int)(?m21 Int) (implies(=(crypt ?m1 ?m2) (crypt ?m11 ?m21)) (and(= ?m1 ?m11) (= ?m2 ?m21))))");
			
			iz3File.write(" )\n"); //close the big AND
			
			iz3File.write(" )\n"); //benchmark
			iz3File.flush();
			iz3File.close();
			b.close();
		}catch(Exception e){
			e.printStackTrace();
			System.exit(0);
		}
		
		
		
	}
	
	public Formula getFormula(){
		Formula f=new Formula();
		return f;
	}
	
}