package se;
import java.util.*;

public abstract class Message implements Evaluable{
	private static int uid=0;
	private static String variableList="";
	String messageString = "";
	
	protected static final int getNewUID(){
		uid++;
		return uid;} 
	
	protected static String getVarsList(){
		return variableList;} 
	
	public static void addVar2VariablesList(String var){
		//here we need the check if the var is already in the list
		//but maybe it becomes too slow
		variableList+=" ("+var+" Int)";
	}
	
	public abstract ParametricMessage eval(Environment env);

	public abstract String print();
	
	public  String interpolantString(Environment env){return "";}
	
	public abstract ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list);
	
	public ParametricMessage eval4Domain(Environment env){return this.eval(env);}

	public abstract Message getAnotherOfTheSameType(String name);
	
	public abstract Evaluable substitute(ArrayList<Pair<Message, Message>> mex_newMex);
	
}