package se;

import java.util.ArrayList;

public abstract class OPConditional extends StdConditional{
	
	private Evaluable lhs;
	private Evaluable rhs;
	
	public OPConditional(Evaluable lhs, Evaluable rhs) {
		this.lhs = lhs;
		this.rhs = rhs;
	}
	
	public void add2Spec(Specification spec){
		spec.addMessage(this.lhs);
		spec.addMessage(this.rhs);
	}
	
//	public OPConditional substitute(ArrayList<Pair<Message, Message>> mex_newMex){
//		Evaluable tmp_lhs=this.lhs.substitute(mex_newMex);
//		Evaluable tmp_rhs=this.rhs.substitute(mex_newMex);
//		return new OPConditional(tmp_lhs,tmp_rhs);
//	}
//	public void modifyActionString(OPConditional cond){
//		cond.modifyActionString(this.lhs,this.rhs);
//	}
//	public void modifyActionString(Evaluable lhs,Evaluable rhs){
//		
//	}
	//make the compiler happy with FactConditional :)
	public OPConditional() {}
	
	public Evaluable getLhs(){return this.lhs;};
	public Evaluable getRhs(){return this.rhs;};
	public void setLhs(Evaluable lhs){this.lhs=lhs;}
	public void setRhs(Evaluable rhs){this.rhs=rhs;}	
	
	public abstract SymbolicDataState se(SymbolicDataState sds);
	/*	OPConstraint OPconstraint = new OPConstraint(lhs.eval(sds.getEnvironment()),rhs.eval(sds.getEnvironment()));
		sds.addConstraint2ConstraintSet(OPconstraint);
		return sds;
	}*/
	
}
