package se;

import java.util.ArrayList;

public abstract class ParametricFunction extends ParametricMessage {
	public abstract String getFunctionName();
	public abstract ParametricTuple getArgs(Environment env);
	public abstract ParametricConstant getCons(Pair<ArrayList<ParametricMessage[]>,ParametricTuple> assignment,Domain dom);
	public abstract void setConstantiz(ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> constantiz);
	public abstract ArrayList<Pair<Pair<ArrayList<ParametricMessage[]>,ParametricTuple>,ParametricConstant>> getContantiz();
	
	public abstract String satString(ArrayList<Pair<ParametricMessage,ParametricMessage>> assignment);
	
	public String satString(Pair<ParametricMessage,ParametricMessage> assignment){
		ArrayList<Pair<ParametricMessage,ParametricMessage>> ass=new ArrayList<Pair<ParametricMessage,ParametricMessage>>();
		ass.add(assignment);
		return this.satString(ass);
	}
	public String satString(){
		System.out.println("you're calling satString() on a function instead of satString(Environment env,ArrayList<Pair<ParametricMessage,ParametricConstant>> assignment)");
		System.exit(0);
		return null;
	}
	public abstract ArrayList<Pair<String,String>> satFunctionString();
	
	public abstract boolean isInvertible();
	public abstract boolean isPublic();
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		System.out.println("FUNCTION not supported (ParametricFunction->getParameters())");
		System.exit(0);
		return params;
	}
}
