package se;

import java.util.ArrayList;

public class ParametricSymKeyConstant extends ParametricSymKey implements ParametricConstant {
	
	private int uid=getNewUID();
	private String name="ParametricSymKeyConstant"+this.getUID();
	
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	
//	public boolean equals(Object pm){
//		boolean ret=false;
//		if(pm==null){return false;}
//		if(pm==this){return true;}
//		
//		if(pm.getClass().equals(ParametricSymKeyConstant.class)){
//			if(this.satString().equals(((ParametricSymKeyConstant)pm).satString())){
//					ret=true;
//			}
//		}
//
//		return ret;
//	}
	
	public String print() {
		return this.getName();
	}
	
	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.getName();
	}
	
	public String getConstant(){
		return this.satString();
	}
	
	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){return pm_list;}
	public void add2Domain(Domain domain){domain.add(this);}
	public void add2Domain(Domain domain,IKStdConstraint ik){domain.add(this,ik);}
	
	public ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair,ParametricSymEncryptedMessage scrypt){
		list.add(this);
		return list;
	}
	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
		if(this.equals(m)){
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else{
			//they're not equal
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
		}
	}
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return params;
	}
	//sat strings
	public String satString(){
		return ""+getUID();
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		return ""+getUID();	
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		return ""+getUID();
	}
}
