package se;


public class PublicKeyConstant extends PublicKey {
	
	public PublicKeyConstant(AgentConstant agent){
		super(agent);
	}
	
	public PublicKeyConstant(AgentConstant agent, String messageString){
		this(agent);
		this.messageString = messageString;
	}
	
	public ParametricPublicKeyConstant eval(Environment env) {
		//Debugging purpose
		//System.out.println("this is the PubKey: "+((ParametricAgent)((this.getAgent()).eval(env))).getPublicKey());
		return ((ParametricAgentConstant)((this.getAgent()).eval(env))).getPublicKey();
	}

	public String print() {
		return "PublicKeyConstant "+this.hashCode()+" of "+this.getAgent().print();
	}
	
}