package se;

import java.util.HashSet;
import java.util.Iterator;

public class TupleSet extends HashSet<Tuple>{
	
	public String interpolantString(Environment env){
		String ret="";
		
		Iterator<Tuple> iterTuple=this.iterator();
		while(iterTuple.hasNext()){
			Tuple currentTuple=iterTuple.next();
			ret+=currentTuple.interpolantString(env);
		}
		
		return ret;
	}
	
	public String interpolantString(){
		String ret="";
		
		Iterator<Tuple> iterTuple=this.iterator();
		while(iterTuple.hasNext()){
			Tuple currentTuple=iterTuple.next();
			ret+=currentTuple.interpolantString();
		}
		
		return ret;
	}
	
	public String print(){
		String ret="";
		
		Iterator<Tuple> iterTuple=this.iterator();
		while(iterTuple.hasNext()){
			Tuple currentTuple=iterTuple.next();
			ret+=currentTuple.print()+"\n";
		}
		
		return "{"+ret+"}";
	}
	
	public ParametricTupleSet eval(Environment env){
		ParametricTupleSet ret=new ParametricTupleSet();
		
		Iterator<Tuple> iterTuple=this.iterator();
		while(iterTuple.hasNext()){
			ret.add(iterTuple.next().eval(env));
		}
		
		return ret;
	}
	
	
}