package translator;

import java.util.ArrayList;
import java.util.HashMap;

import se.AgentConstant;

/**
 * Class representing the root entity.
 *
 * @author Fabio Pettenuzzo
 * @author Marco Palamà
 * @version 1.0, 12/13
 */
public class Environment extends Entity {	
	
	ArrayList<HashMap<String, String>> sessions;
	
	/**
	 * Constructor of the Environment class.
	 * @param parent The parent entity, this value should be null
	 * @param name The root entity name
	 */
	Environment(Entity parent, String name){
		super(parent, name);
		if(parent != null) { System.out.println("Error - Entity "+ getName() +": Wrong nesting."); System.exit(3);}
		addSymbol("i", new AgentConstant("i")); // The special symbol "i" is added by default.
	}
	
	
	

}
