package se;

public abstract class Agent extends Message {

	private PublicKey publicKey;
	private PrivateKey privateKey;
	
	public Agent(){
		this.publicKey=new PublicKey(this);
		this.privateKey=new PrivateKey(this);
	}
	
	public Agent(String messageString){
		this.messageString = messageString;
	}

	public PublicKey getPublicKey(){
		return publicKey;
	}
	
	public PrivateKey getPrivateKey(){
		return privateKey;
	}
	
	public String toString(){
		return this.messageString;
	}
}