package se;

import java.util.ArrayList;


public class FactConstraint extends OPConstraint{
	
	FactVariable factvar;
	ParametricTuple parametricTuple;
	Value booleanConstant;
	
	public FactConstraint(FactVariable factvar,ParametricTuple parametricTuple,Value booleanConstant){
		this.factvar=factvar;
		this.parametricTuple=parametricTuple;
		this.booleanConstant=booleanConstant;
	}
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		return this.parametricTuple.getParameters(params);
	}
	
	public String print() {
		return "(= ("+this.factvar.getName()+" "+this.parametricTuple.satString()+") "+this.booleanConstant.satString()+")";
	}

	public String print(int i) {
		return "(= ("+this.factvar.getName()+" "+this.parametricTuple.satString()+") "+this.booleanConstant.satString()+")";
	}
	
	public String getConstantsFromConstraint(){
		return "";
	}
	
	
	//satprint
	public String satPrint(Domain dom){
		return "(= ("+this.factvar.getName()+" "+this.parametricTuple.satString()+") "+this.booleanConstant.satString()+") \n";
	}
	public String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom){
		return "(= ("+this.factvar.getName()+" "+this.parametricTuple.satString(assignment)+") "+this.booleanConstant.satString(assignment)+")\n";
	}
	public String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom){
		return "(= ("+this.factvar.getName()+" "+this.parametricTuple.satString(assignment)+") "+this.booleanConstant.satString(assignment)+")\n";
	}
}