package se;

import java.util.*;

public abstract class Function extends Message {
	
	public abstract ParametricFunction eval(Environment env);
	
	//interpolantString is useless for functions
	//we in fact re-define the method in
	public abstract String interpolantString(Environment env,ArrayList<Pair<Message,ParametricMessage>> assignment);
	
	public String interpolantString(Environment env,Pair<Message,ParametricMessage> assignment){
		ArrayList<Pair<Message,ParametricMessage>> ass=new ArrayList<Pair<Message,ParametricMessage>>();
		ass.add(assignment);
		return this.interpolantString(env,ass);
	}
	public String interpolantString(Environment env){
//		StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
//		for(int i=0;i<stackTraceElements.length;i++){
//			System.out.println(stackTraceElements[i].getClassName());
//			System.out.println(stackTraceElements[i].getLineNumber());
//		}
		System.out.println("you're calling interpolantString(env) on a function instead of " +
				"interpolantString(Environment env,ArrayList<Pair<Message,ParametricMessage>> assignment)");
		System.exit(0);
		return null;
	}
	
	public abstract String print();
	
	public ArrayList<ArrayList<Message>> getVars(ArrayList<ArrayList<Message>> list){
		return this.getArgs().getVars(list);	
	}
	
	public Message getAnotherOfTheSameType(String name){
		return null;
	}
	
	//gets and sets
	public abstract String getName();
	public abstract Tuple getArgs();
	public abstract void setConstantiz(ArrayList<Pair<Pair<ArrayList<Pair<Message,ParametricMessage>>,ParametricTuple>,ParametricConstant>> constantiz);
	public abstract boolean isInvertible();
	public abstract boolean isPublic();
	
}
