package se;

import java.util.ArrayList;

public class GenericMessageParameter extends GenericParameter implements Parameter{
	
	private int uid=getNewUID();
	private String name="GenericMessdageParameter"+this.getUID();
	
	public GenericMessageParameter(){
	ParametricMessage.addVar2VariablesList("GMP"+getUID());
	}
	
	public int getUID(){return this.uid;}
	public String getName(){return this.name;}
	

	public String getConstant(){
		return this.satString();
	}
	public String print() {
		return this.getName();
	}
	
	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.getName();
	}
	
	public ArrayList<ParametricMessage> getPvtKey(ArrayList<ParametricMessage> pm_list){return pm_list;}
	public void add2Domain(Domain domain){
		domain.add2DomainPMparams(this);
		domain.add(this);
	}
	public void add2Domain(Domain domain,IKStdConstraint ik){domain.add2DomainPMparams(this);domain.add(this,ik);}
	
	public ArrayList<ParametricMessage> Msg2List(ArrayList<ParametricMessage> list,ParametricEncryptedMessage enc,ParametricConcatenatedMessage pair,ParametricSymEncryptedMessage scrypt){
		list.add(this);
		return list;
	}
	public Pair<Boolean,ArrayList<ParametricMessage[]>> compare(ParametricMessage m,ArrayList<ParametricMessage[]> l){
		if(m.getClass().equals(ParametricGenericConstant.class)){
			//they're similar
			//add the assignment to l
			ParametricMessage[] ret=new ParametricMessage[2];
			ret[0]=this;
			ret[1]=m;
			l.add(ret);
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else if(this.equals(m)){
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(true,l);
		}else{
			//they're not equal
			return new Pair<Boolean, ArrayList<ParametricMessage[]>>(false,null);
		}
	}
	
	public boolean sameEquivalenceClass(ParametricMessage pm){
		if(this.getClass().equals(pm.getClass())){
			return true;
		}else 
			return false;
	}
	
	//sat strings
	public String satString(){
		return "GMP"+getUID();
	}
	public String satString(Pair<ParametricMessage, ParametricMessage> assignment){
		if(assignment.getElement0().satString().equals(this.satString()))
			return assignment.getElement1().satString();
		
		return this.satString();
	}
	public String satString(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment){
		if(assignment.isEmpty()){
			return this.satString();
		}else
		for(int i=0;i<assignment.size();i++){
			if(assignment.get(i).getElement0().satString().equals(this.satString())){
				return assignment.get(i).getElement1().satString();
			}
		}
		
		return this.satString();
	}
	
	public ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params){
		boolean found=false;
		for(int i=0;i<params.size();i++)
			if(params.get(i).satString().equals(this.satString())){
				found=true;
				break;
			}
		if(!found)
			params.add(this);
		
		return params;
	}
}