package se;

import java.util.ArrayList;

public abstract class GenericParameter extends ParametricMessage implements Parameter{
	
	public StdConstraint matches(ParametricMessage m){
		if (m instanceof GenericParameter){
			return new EqOPConstraint(m,this);
		}
		else
			return False.getInstance();			
	}
	
	public String print() {
		return "GenericParameter " + this.hashCode();
	}	

	public String print(int i) {
		int j;
		String string="";
		for (j=0;j<i;j++){
			string = string + "\t";
		}
		return string+this.hashCode();
	}
	public ArrayList<ArrayList<ParametricMessage>> getParams(ArrayList<ArrayList<ParametricMessage>> params){
		boolean added=false;
		
		for(int i=0;i<params.size();i++)
			if(params.get(i).get(0).getClass().equals(this.getClass())){
				params.get(i).add(this);
				added=true;
			}
		
		if(!added){
			ArrayList<ParametricMessage> temp=new ArrayList<ParametricMessage>();
			temp.add(this);
			params.add(temp);
		}
		return params;
	}

}