package se;


public abstract class ParametricKey extends ParametricMessage {

	private ParametricAgent parametricAgent;
	private int uid=getNewUID();
	private String name="ParametricKey"+this.getUID();
	
	public ParametricKey(ParametricAgent parametricAgent){
		this.setParametricAgent(parametricAgent);
	}
	
//	public ParametricKey(){
//	}
	
	public void setParametricAgent(ParametricAgent parametricAgent){this.parametricAgent=parametricAgent;}
	public ParametricAgent getParametricAgent(){return this.parametricAgent;}

	// returns the constraint obtained by trying to let this parametric message
	// match with m (no matter which IKSet is being considered)
	public StdConstraint matches(ParametricMessage m){
		if (m.getClass() == this.getClass()){
			ParametricKey em = (ParametricKey)m;
			return new EqOPConstraint(em.getParametricAgent(),this.getParametricAgent());
		}
		else
			return False.getInstance();			
	}
	
	
}
