package se;

import java.util.ArrayList;

public abstract class StdConstraint extends Constraint{
	
	private static String dyList="";
	protected static String getdyList(){
		return dyList;}
	public static void adddy2List(String dy){
		dyList+=" ("+dy+" Int)";
	}
	
	
	public boolean equalTo(StdConstraint stdConstraint){
		boolean ret=false;
		
		if(this instanceof ConjunctiveConstraint){
			ret=((ConjunctiveConstraint)this).equalTo(stdConstraint);
		}else if(this instanceof DisjunctiveConstraint){
			ret=((DisjunctiveConstraint)this).equalTo(stdConstraint);
		}else if(this instanceof OPConstraint){
			ret=((OPConstraint)this).equalTo(stdConstraint);
		}else if(this instanceof True){
			ret=((True)this).equalTo(stdConstraint);
		}else if(this instanceof False){
			ret=((False)this).equalTo(stdConstraint);
		}
		return ret;
	}
	
//	public abstract String satPrint(StdConstraintSet cs,String[] constansSet);
	public abstract String satPrint(Domain dom);
	public abstract String satPrint(Pair<ParametricMessage, ParametricMessage> assignment,Domain dom);
	public abstract String satPrint(ArrayList<Pair<ParametricMessage, ParametricMessage>> assignment,Domain dom);
	
	public abstract String print();
	public abstract String getConstantsFromConstraint();
	public abstract void createDomain(Domain domain);
	public abstract ArrayList<ParametricMessage> getParameters(ArrayList<ParametricMessage> params);
}